Drawing Workbench: Difference between revisions

From FreeCAD Documentation
(typos)
No edit summary
Line 1: Line 1:
The Drawing module is made to allow you to put your 3D work on paper. That is, to put views of your models in a 2D window, and to insert that window in a drawing, for example a sheet, with a border, a title and your logo, and finally to print that sheet. The Drawing module is currently under construction and more or less a technology preview!
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window, and to insert that window in a drawing, for example a sheet, with a border, a title and your logo, and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!


== GUI Tools ==
[[Image:Drawing_extraction.png]]


{{Drawing Tools}}
In the picture you see the main concepts of the Drawing module. The document contains a Shape object (Schenkel) which
we want to extract to a drawing. Therefore a "Page" was created. A page gets instantiated through a template.
In this case A3_Landscape. The Template is a SVG document which holds frames, logos and complies to some
kind of standard.


In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor
(Property scale) and additional properties. Every time the page or the view or the referenced object changes,
the page gets regenerated and the page display updated.


[[Image:Drawing_extraction.png|800px]]
=== Scripting ===
At the moment the end user work flows are very limited. So maybe the scripting is more interesting.
example how to use the scripting API of the drawing module


In the picture you see the main concepts of the Drawing module. The document contains a Shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The Template is a SVG document which can hold your usual page frame, your logo or comply to your presentation standards.
example how to use the scripting API of the drawing module


In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes, the page gets regenerated and the page display updated.
first of all you need the Part and the Drawing module:

== Scripting ==

At the moment the end user(GUI) workflow are very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.

=== Simple example ===

First of all you need the Part and the Drawing module:
import FreeCAD, Part, Drawing
import FreeCAD, Part, Drawing
create a small sample part
Create a small sample part
Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))
Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))
direct projection. The G0 means hard edge, the G1 is tangend continues.
Direct projection. The G0 means hard edge, the G1 is tangend continues.
Shape = App.ActiveDocument.Shape.Shape
Shape = App.ActiveDocument.Shape.Shape
[visiblyG0,visiblyG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
print "visible edges:", len(visiblyG0.Edges)
print "visible edges:", len(visibleG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)
all was projected on the Z-plane:
Everything was projected on the Z-plane:
print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box project: X=",visiblyG0.BoundBox.XLength," Y=",visiblyG0.BoundBox.YLength," Z=",visiblyG0.BoundBox.ZLength
print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength
different projection vector
Different projection vector
[visiblyG0,visiblyG1,hiddenG0,hiddenG1] = Drawing.project(Shape,Base.Vector(1,1,1))
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,Base.Vector(1,1,1))
project to SVG
Project to SVG
resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
print resultSVG
print resultSVG
And now the parametric way
=== The parametric way ===


insert a Page object and assign a template
Insert a Page object and assign a template
App.activeDocument().addObject('Drawing::FeaturePage','Page')
App.activeDocument().addObject('Drawing::FeaturePage','Page')
App.activeDocument().Page.Template = App.ConfigGet('AppHomePath')+'Mod/Drawing/Templates/A3_Landscape.svg'
App.activeDocument().Page.Template = App.ConfigGet('AppHomePath')+'Mod/Drawing/Templates/A3_Landscape.svg'
create a view on the "Shape" object, define the position and scale and assign it to a Page
Create a view on the "Shape" object, define the position and scale and assign it to a Page
App.activeDocument().addObject('Drawing::FeatureViewPart','View')
App.activeDocument().addObject('Drawing::FeatureViewPart','View')
App.activeDocument().View.Source = App.activeDocument().Shape
App.activeDocument().View.Source = App.activeDocument().Shape
Line 54: Line 54:
App.activeDocument().Page.addObject(App.activeDocument().View)
App.activeDocument().Page.addObject(App.activeDocument().View)
create a second view on the same object but the view is
Create a second view on the same object but this time the view will be rotated by 90 degrees.
rotated 90 degrees.
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewRot')
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewRot')
App.activeDocument().ViewRot.Source = App.activeDocument().Shape
App.activeDocument().ViewRot.Source = App.activeDocument().Shape
Line 65: Line 64:
App.activeDocument().Page.addObject(App.activeDocument().ViewRot)
App.activeDocument().Page.addObject(App.activeDocument().ViewRot)
create a third view on the same object but with an isometric
Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.
view direction. Also the hidden lines are activated.
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewIso')
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewIso')
App.activeDocument().ViewIso.Source = App.activeDocument().Shape
App.activeDocument().ViewIso.Source = App.activeDocument().Shape
Line 76: Line 73:
App.activeDocument().Page.addObject(App.activeDocument().ViewIso)
App.activeDocument().Page.addObject(App.activeDocument().ViewIso)
change something and update.
Change something and update. The update process changes the view and the page.
The update process change the view and the page
App.activeDocument().View.X = 30.0
App.activeDocument().View.X = 30.0
App.activeDocument().View.Y = 30.0
App.activeDocument().View.Y = 30.0
Line 83: Line 79:
App.activeDocument().recompute()
App.activeDocument().recompute()
Accessing the bits and peaces:
=== Accessing the bits and pieces ===

get the SVG fragment of a single view
Get the SVG fragment of a single view
ViewSVG = App.activeDocument().View.ViewResult
ViewSVG = App.activeDocument().View.ViewResult
print ViewSVG
print ViewSVG
get the hole result page (its a file in the document temp dir, only read allowed)
Get the hole result page (its a file in the document temp dir, only read allowed)
print "Resulting SVG document: ",App.activeDocument().Page.PageResult
print "Resulting SVG document: ",App.activeDocument().Page.PageResult
file = open(App.activeDocument().Page.PageResult,"r")
file = open(App.activeDocument().Page.PageResult,"r")
print "Result page is ",len(file.readlines())," lines long"
print "Result page is ",len(file.readlines())," lines long"

important, give free the file!
Important: free the file!
del file
del file
insert a view with your own content:
Insert a view with your own content:
App.activeDocument().addObject('Drawing::FeatureView','ViewSelf')
App.activeDocument().addObject('Drawing::FeatureView','ViewSelf')
App.activeDocument().ViewSelf.ViewResult = """<g id="ViewSelf"
App.activeDocument().ViewSelf.ViewResult = """<g id="ViewSelf"
Line 104: Line 102:
transform="translate(30,30)"
transform="translate(30,30)"
fill="#00cc00"
fill="#00cc00"
>
>
<ellipse cx="40" cy="40" rx="30" ry="15"/>
<ellipse cx="40" cy="40" rx="30" ry="15"/>
</g>
</g>
"""
"""
App.activeDocument().Page.addObject(App.activeDocument().ViewSelf)
App.activeDocument().Page.addObject(App.activeDocument().ViewSelf)
App.activeDocument().recompute()
App.activeDocument().recompute()
del Shape,ViewSVG, resultSVG
del Shape,ViewSVG, resultSVG
That leads to the following result:


[[Image:DrawingScriptResult.jpg|800px]]

That leads to following result:

[[Image:DrawingScriptResult.jpg]]





Revision as of 19:21, 24 November 2009

The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window, and to insert that window in a drawing, for example a sheet, with a border, a title and your logo, and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!

GUI Tools

Template:Drawing Tools


In the picture you see the main concepts of the Drawing module. The document contains a Shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The Template is a SVG document which can hold your usual page frame, your logo or comply to your presentation standards.

In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes, the page gets regenerated and the page display updated.

Scripting

At the moment the end user(GUI) workflow are very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.

Simple example

First of all you need the Part and the Drawing module:

import FreeCAD, Part, Drawing

Create a small sample part

Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))

Direct projection. The G0 means hard edge, the G1 is tangend continues.

Shape = App.ActiveDocument.Shape.Shape
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
print "visible edges:", len(visibleG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)

Everything was projected on the Z-plane:

print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength

Different projection vector

[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,Base.Vector(1,1,1))

Project to SVG

resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
print resultSVG

The parametric way

Insert a Page object and assign a template

App.activeDocument().addObject('Drawing::FeaturePage','Page')
App.activeDocument().Page.Template = App.ConfigGet('AppHomePath')+'Mod/Drawing/Templates/A3_Landscape.svg'

Create a view on the "Shape" object, define the position and scale and assign it to a Page

App.activeDocument().addObject('Drawing::FeatureViewPart','View')
App.activeDocument().View.Source = App.activeDocument().Shape
App.activeDocument().View.Direction = (0.0,0.0,1.0)
App.activeDocument().View.X = 10.0
App.activeDocument().View.Y = 10.0
App.activeDocument().Page.addObject(App.activeDocument().View)

Create a second view on the same object but this time the view will be rotated by 90 degrees.

App.activeDocument().addObject('Drawing::FeatureViewPart','ViewRot')
App.activeDocument().ViewRot.Source = App.activeDocument().Shape
App.activeDocument().ViewRot.Direction = (0.0,0.0,1.0)
App.activeDocument().ViewRot.X = 290.0
App.activeDocument().ViewRot.Y = 30.0
App.activeDocument().ViewRot.Scale = 1.0
App.activeDocument().ViewRot.Rotation = 90.0
App.activeDocument().Page.addObject(App.activeDocument().ViewRot) 

Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.

App.activeDocument().addObject('Drawing::FeatureViewPart','ViewIso')
App.activeDocument().ViewIso.Source = App.activeDocument().Shape
App.activeDocument().ViewIso.Direction = (1.0,1.0,1.0)
App.activeDocument().ViewIso.X = 335.0
App.activeDocument().ViewIso.Y = 140.0
App.activeDocument().ViewIso.ShowHiddenLines = True
App.activeDocument().Page.addObject(App.activeDocument().ViewIso) 

Change something and update. The update process changes the view and the page.

App.activeDocument().View.X = 30.0
App.activeDocument().View.Y = 30.0
App.activeDocument().View.Scale = 1.5
App.activeDocument().recompute()

Accessing the bits and pieces

Get the SVG fragment of a single view

ViewSVG = App.activeDocument().View.ViewResult
print ViewSVG

Get the hole result page (its a file in the document temp dir, only read allowed)

print "Resulting SVG document: ",App.activeDocument().Page.PageResult
file = open(App.activeDocument().Page.PageResult,"r")
print "Result page is ",len(file.readlines())," lines long"

Important: free the file!

del file

Insert a view with your own content:

App.activeDocument().addObject('Drawing::FeatureView','ViewSelf')
App.activeDocument().ViewSelf.ViewResult = """<g id="ViewSelf"
  stroke="rgb(0, 0, 0)"
  stroke-width="0.35"
  stroke-linecap="butt"
  stroke-linejoin="miter"
  transform="translate(30,30)"
  fill="#00cc00"
  >

  <ellipse cx="40" cy="40" rx="30" ry="15"/>
  </g>
"""
App.activeDocument().Page.addObject(App.activeDocument().ViewSelf)
App.activeDocument().recompute()

del Shape,ViewSVG, resultSVG

That leads to the following result: